#!/bin/bash
#
#***************************************************************************
# Author: liwanggui
# Email: liwanggui@163.com
# Date: 2021-11-16
# FileName: exporter.sh
# Description: 数据采集脚本运行入口
# Copyright (C): 2021 All rights reserved
#***************************************************************************
#
## crontab ##
#  * * * * * /bin/bash /usr/local/node_exporter/scripts/exporter.sh >/dev/null 2>&1
##

path="/usr/local/node_exporter/scripts"
# crontab 执行最小时间
end_time=$(($(date +%s) + 60))
# 任务间隔(秒)，用于配合 crontab 实现秒级任务
# 运行一次数据采集脚本的间隔
step=35

# 清理旧的数据文件
/bin/rm -f /usr/local/node_exporter/metrics/*.prom

while [[ $end_time -gt $(date +%s) ]]; do
   for ext in ${path}/*_exporter.sh ; do
       if [[ $(basename $ext) == "exporter.sh" ]] || [[ $(basename $ext) == "*_exporter.sh" ]]; then
           continue
       fi
       /bin/bash $ext run
   done
   sleep $step
done
