var admin = db.getSiblingDB('admin')
var serverStatus = admin.serverStatus()
var label_port= "port=\"" + admin.getMongo().host.split(':')[1] + "\""
var labels = label_port

var metrics = {}

if (serverStatus.hasOwnProperty("repl")) {
    if (serverStatus.repl.setName == "configReplSet"){
        labels = labels + ",role=\"shardsvr\""
    }else{
        labels = labels + ",role=\"mongod\""
    }

    if (serverStatus.repl.ismaster) {
        labels = labels + ",rs_role=\"master\""
    }else if (serverStatus.repl.secondary){
        labels = labels + ",rs_role=\"secondary\""
    }else if (serverStatus.repl.arbiterOnly){
        labels = labels + ",rs_role=\"arbiter\""
    }
}

metrics["mongod_up{" + label_port +"}"] = 1
metrics["mongod_uptime_in_seconds{" + labels +"}"] = serverStatus.uptime
metrics["mongod_network_bytesIn{" + labels +"}"] = serverStatus.network.bytesIn.floatApprox
metrics["mongod_network_bytesOut{" + labels +"}"]= serverStatus.network.bytesOut.floatApprox

metrics["mongod_page_faults_total{" + labels +"}"] = Number(serverStatus.extra_info.page_faults)

metrics["mongod_connections{" + labels + ",state=\"current\"}"] = serverStatus.connections.current
metrics["mongod_connections{" + labels + ",state=\"available\"}"] = serverStatus.connections.available
metrics["mongod_connections{" + labels + ",state=\"totalCreated\"}"] = serverStatus.connections.totalCreated

metrics["mongod_memory_resident_mb{" + labels + ",state=\"totalCreated\"}"] = serverStatus.mem.resident
// metrics["mongod_memory_virtual{" + labels + ",state=\"totalCreated\"}"] = serverStatus.mem.virtual

metrics["mongod_command_total{" + labels + ",command=\"total\"}"] = Number(serverStatus.opcounters.command)
metrics["mongod_command_total{" + labels + ",command=\"insert\"}"] = Number(serverStatus.opcounters.insert)
metrics["mongod_command_total{" + labels + ",command=\"query\"}"] = Number(serverStatus.opcounters.query)
metrics["mongod_command_total{" + labels + ",command=\"update\"}"] = Number(serverStatus.opcounters.update)
metrics["mongod_command_total{" + labels + ",command=\"delete\"}"] = Number(serverStatus.opcounters.delete)

metrics["mongod_wiredTiger_cache_config_bytes{" + labels + "}"] = serverStatus.wiredTiger.cache["maximum bytes configured"]
metrics["mongod_wiredTiger_cache_currently_used_bytes{" + labels + "}"] = serverStatus.wiredTiger.cache["bytes currently in the cache"]

metrics["mongod_globalLock_currentQueue{" + labels + ",state=\"total\"}"] = serverStatus.globalLock.currentQueue.total
metrics["mongod_globalLock_currentQueue{" + labels + ",state=\"readers\"}"] = serverStatus.globalLock.currentQueue.readers
metrics["mongod_globalLock_currentQueue{" + labels + ",state=\"writers\"}"] = serverStatus.globalLock.currentQueue.writers


for (k in metrics){
    print(k, metrics[k])
}
